% ranks(thr,N) returns the vector of ranks that correspond to the first
% elements of N to be higher than the thresholds in thr

function [output] = ranks(thr,N)

T = length(thr);
M = max(N);

output = zeros(size(thr));

for i=1:T
    if M>thr(i)
        output(i) = find(N(:)>=thr(i),1);
    else % if no element in N is higher than thr(i), the rank is infinite
        output(i) = Inf;
    end
end