%% Approximation of the derivatives of the Pareto curve at the raw data thresholds
%
% Method: Three-point difference
%

function [dd] = approx_deriv(pp,aa)

T = length(pp);

dd = zeros(T,1);

dd(1) = (-aa(3)+4*aa(2)-3*aa(1))/(pp(3)-pp(1));

dd(2:end-1) = aa(1:end-2).*(pp(2:end-1)-pp(3:end))./((pp(1:end-2)-pp(2:end-1)).*(pp(1:end-2)-pp(3:end)))+aa(2:end-1).*(2*pp(2:end-1)-pp(1:end-2)-pp(3:end))./((pp(2:end-1)-pp(1:end-2)).*(pp(2:end-1)-pp(3:end)))+aa(3:end).*(pp(2:end-1)-pp(1:end-2))./((pp(3:end)-pp(1:end-2)).*(pp(3:end)-pp(2:end-1)));

dd(end) = (3*aa(end)-4*aa(end-1)+aa(end-2))/(pp(end)-pp(end-2));
